function heMatrix = mapToExtendedEmbedding(hcMatrix, dec, zerotol, ...
    partitionVector)
% map hC-vector to the extended embedding
%
% Syntax: heMatrix = convertToProperEmbedding(hcMatrix, dec)
%
% With mapToExtendedEmbedding(.., zerotol, partitionVector), the tolerance
%   can be set and the unified partitions in the extended embeding can
%   be provided. Both are optional arguments.
%
% See also: computeExtendedEmbedding, approximateDec

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2013 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

if ~exist('zerotol', 'var') || isempty(zerotol)
    zerotol = elkZerotol;
end
if ~exist('partitionVector', 'var') || isempty(partitionVector)
    partitionVector = computePartitionIndexDec(dec.originalData, ...
        hcMatrix, zerotol, 1);
end

% the maping information is already present in dec.originalData and we can
%   cycle through the unified partitions.
heMatrix = zeros(dec.nC, size(hcMatrix, 2));
for iPart = 1:dec.originalData.nPU
    thisFilter = partitionVector == iPart;
    
    heMatrix(:, thisFilter) = dec.originalData.mappingOriginalToNewList{...
        iPart} * hcMatrix(:, thisFilter);
end